<?php

namespace Intergo\UserCallbackClient;

use Intergo\UserCallbackClient\Enums\UserCallbackEnum;
use Intergo\UserCallbackClient\Exceptions\InvalidCallbackData;
use Intergo\UserCallbackClient\Jobs\SendCallback;

class UserCallbackManager
{
    /**
     * @param SendCallbackData $data
     * @throws InvalidCallbackData
     */
    public static function send(SendCallbackData $data)
    {
        if (empty($data->callbackUrl) || empty($data->payload)) {
            throw new InvalidCallbackData('Invalid callback data');
        }
        $queue = empty($data->customQueue) ? UserCallbackEnum::CALLBACKS_QUEUE : $data->customQueue;
        dispatch(new SendCallback($data))->onQueue($queue);
    }
}